defmodule ClickHouse.Interface do
  @moduledoc """
  A behaviour to implement an interface to interact with a ClickHouse server.
  """

  @type error ::
          ClickHouse.ConnectionError.t()
          | ClickHouse.DatabaseError.t()
          | ClickHouse.NetworkError.t()
          | ClickHouse.ParsingError.t()

  @callback start_link(keyword()) :: GenServer.on_start()
  @callback execute(query :: ClickHouse.Query.t()) ::
              {:ok, ClickHouse.Result.t()} | {:error, error()}
end
